from .const import BASE, CONST, VAR
from .wtypes import *


def test_union_index():
    t = union([
        ('FOO', [int_]),
        ('BAR', []),
        ('FOO', [str_]),
    ])
    _, (cases,) = switch(t)
    index = union_index(cases)
    assert len(index) == 2
    assert len(index['FOO']) == 1
    assert index['FOO'][0].read() == int_.read()
    assert len(index['BAR']) == 0


def test_sizes():
    # Check sizes.
    for t in [
        bool_, float_, int_, str_,
        ref(BASE, int_),
        array0,
        array(BASE, int_),
        struct([int_]),
        union([('None', []), ('Some', [int_])]),
        function([], bool_),
        dynamic,
    ]:
        assert sizeof(t) > 0
